# knife data bag

A data bag is a global variable that is stored as JSON data and is accessible from a Chef server. A data bag is indexed for searching and can be loaded by a recipe or accessed during a search.

A data bag item may be encrypted using shared secret encryption. This allows each data bag item to store confidential information (such as a database password) or to be managed in a source control system (without plain-text data appearing in revision history). Each data bag item may be encrypted individually; if a data bag contains multiple encrypted data bag items, these data bag items are not required to share the same encryption keys.

The knife data bag subcommand is used to manage arbitrary stores of globally available JSON data.

Note

Review the list of common options available to this (and all) knife subcommands and plugins.

## create

The `create` argument is used to add a data bag to the Chef server.

### Syntax

This argument has the following syntax:

    $ knife data bag create DATA_BAG_NAME [DATA_BAG_ITEM] (options)

### Options

This argument has the following options:

`DATA_BAG_ITEM`
  The name of a specific item within a data bag.
`--secret SECRET`
  The encryption key that is used for values contained within a data bag item. If `secret` is not specified, the chef-client will look for a secret at the path specified by the `encrypted_data_bag_secret` setting in the client.rb file.
`--secret-file FILE`
  The path to the file that contains the encryption key.

Note

For encrypted data bag items, use either `--secret` or `--secret-file`, not both.

### Examples

The following examples show how to use this knife subcommand:

Create a data bag

To create a data bag named “admins”, enter:

    $ knife data bag create admins

to return:

    Created data_bag[admins]

## delete

The `delete` argument is used to delete a data bag or a data bag item from a Chef server.

### Syntax

This argument has the following syntax:

    $ knife data bag delete DATA_BAG_NAME [DATA_BAG_ITEM] (options)

### Options

This argument has the following options:

`DATA_BAG_ITEM`
  The name of a specific item within a data bag.

### Examples

The following examples show how to use this knife subcommand:

Delete a data bag

    $ knife data bag delete data_bag_name

Delete a data bag item

To delete an item named “charlie”, enter:

    $ knife data bag delete admins charlie

Type `Y` to confirm a deletion.

## edit

The `edit` argument is used to edit the data contained in a data bag. If encryption is being used, the data bag will be decrypted, the data will be made available in the $EDITOR, and then encrypted again before saving it to the Chef server.

### Syntax

This argument has the following syntax:

    $ knife data bag edit DATA_BAG_NAME [DATA_BAG_ITEM] (options)

### Options

This argument has the following options:

`DATA_BAG_ITEM`
  The name of a specific item within a data bag.
`--secret SECRET`
  The encryption key that is used for values contained within a data bag item. If `secret` is not specified, the chef-client will look for a secret at the path specified by the `encrypted_data_bag_secret` setting in the client.rb file.
`--secret-file FILE`
  The path to the file that contains the encryption key.

Note

For encrypted data bag items, use either `--secret` or `--secret-file`, not both.

### Examples

The following examples show how to use this knife subcommand:

Edit a data bag

To edit the contents of a data bag, enter:

    $ knife data bag edit dogs tibetanspaniel

where `dogs` is the name of the data bag and `tibetanspaniel` is the name of the data bag item. This will return something similar to the following in the knife editor:

    {
      "name":"data_bag_item_dogs_tibetanspaniel",
      "json_class":"Chef::DataBagItem",
      "chef_type":"data_bag_item",
      "data_bag":"dogs",
      "raw_data":
        {
          "description":"small dog that likes to sit in windows",
          "id":"tibetanspaniel"
        }
    }

Make the necessary changes to the key-value pairs under `raw_data` and save them.

Edit a data bag item

To edit an item named “charlie” that is contained in a data bag named “admins”, enter:

    $ knife data bag edit admins charlie

to open the $EDITOR. Once opened, you can update the data before saving it to the Chef server. For example, by changing:

    {
       "id": "charlie"
    }

to:

    {
       "id": "charlie",
       "uid": 1005,
       "gid": "ops",
       "shell": "/bin/zsh",
       "comment": "Crazy Charlie"
    }

## from file

The `from file` argument is used to:

- Add a data bag item to a data bag
- Update the contents of an existing data bag item

The data bag itself must already exist on the Chef server and must be specified as part of the command. The contents of the data bag item are specified using a JSON file. This JSON file may be located at a relative or absolute path; its location must be specified as part of the command. The JSON file that defines the contents of the data bag item must at least contain the name of the data bag item—`"id": "name"`.

Warning

A chef-client must be version 11.6 (or higher) when using the `knife data bag from file` argument with the Enterprise Chef or Open Source Chef version 11 servers.

### Syntax

This argument has the following syntax:

    $ knife data bag from file DATA_BAG_NAME_or_PATH

### Options

This argument has the following options:

`-a`, `--all`
  Use to upload all data bags found at the specified path.
`--secret SECRET`
  The encryption key that is used for values contained within a data bag item. If `secret` is not specified, the chef-client will look for a secret at the path specified by the `encrypted_data_bag_secret` setting in the client.rb file.
`--secret-file FILE`
  The path to the file that contains the encryption key.

Note

For encrypted data bag items, use either `--secret` or `--secret-file`, not both.

### Examples

The following examples show how to use this knife subcommand:

Create a data bag from a file

To create a data bag on the Chef server from a file:

    $ knife data bag from file "path to JSON file"

Create an encrypted data bag from a file

To create a data bag named “devops_data” that contains encrypted data, enter:

    $ knife data bag from file devops_data --secret-file "path to decryption file"

## list

The `list` argument is used to view a list of data bags that are currently available on the Chef server.

### Syntax

This argument has the following syntax:

    $ knife data bag list

### Options

This argument has the following options:

`-w`, `--with-uri`
  Use to show the corresponding URIs.

### Examples

The following examples show how to use this knife subcommand:

View a list of data bags

    $ knife data bag list

## show

The `show` argument is used to view the contents of a data bag.

### Syntax

This argument has the following syntax:

    $ knife data bag show DATA_BAG_NAME (options)

### Options

This argument has the following options:

`DATA_BAG_ITEM`
  The name of a specific item within a data bag.
`--secret SECRET`
  The encryption key that is used for values contained within a data bag item. If `secret` is not specified, the chef-client will look for a secret at the path specified by the `encrypted_data_bag_secret` setting in the client.rb file.
`--secret-file FILE`
  The path to the file that contains the encryption key.

Note

For encrypted data bag items, use either `--secret` or `--secret-file`, not both.

### Examples

The following examples show how to use this knife subcommand:

Show a data bag

    $ knife data bag show admins

to return something like:

    charlie

Show a data bag item

To show the contents of a specific item within data bag, enter:

    $ knife data bag show admins charlie

to return:

    comment:  Crazy Charlie
    gid:      ops
    id:       charlie
    shell:    /bin/zsh
    uid:      1005

Show a data bag, encrypted

To show the contents of a data bag named `passwords` with an item that contains encrypted data named `mysql`, enter:

    $ knife data bag show passwords mysql

to return:

    ## sample:
    {
      "id": "mysql",
      "pass": "trywgFA6R70NO28PNhMpGhEvKBZuxouemnbnAUQsUyo=\n",
      "user": "e/p+8WJYVHY9fHcEgAAReg==\n"
    }

Show a data bag, decrypted

To show the decrypted contents of the same data bag, enter:

    $ knife data bag show --secret-file /path/to/decryption/file passwords mysql

to return:

    ## sample:
    {
      "id": "mysql",
      "pass": "thesecret123",
      "user": "fred"
    }

Show a data bag as JSON

To view information in JSON format, use the `-F` common option as part of the command like this:

    $ knife data bag show admins -F json

Other formats available include `text`, `yaml`, and `pp`.